/**
 * Setting 部件模型
 *
 * @export
 * @class SettingModel
 */
export default class SettingModel {

    /**
     * 菜单项集合
     *
     * @private
     * @type {any[]}
     * @memberof SettingModel
     */
    private items: any[] = [
                {
        	id: 'FDC4FD25-BAC5-467E-B000-5A118E2A3AFE',
        	name: 'menuitem1',
        	text: '链接角色',
        	type: 'MENUITEM',
        	counterid: '',
        	tooltip: '链接角色',
        	expanded: false,
        	separator: false,
        	hidden: false,
        	hidesidebar: false,
        	opendefault: false,
        	iconcls: 'fa fa-connectdevelop',
        	icon: '',
        	textcls: '',
        	appfunctag: '_5',
        	appfuncyype: 'APPVIEW',
        	viewname: 'connection-role-grid-view',
        	resourcetag: '',
        }
        ,
    ];

	/**
	 * 应用功能集合
	 *
	 * @private
	 * @type {any[]}
	 * @memberof SettingModel
	 */
	private funcs: any[] = [
	];

    /**
     * 获取所有菜单项集合
     *
     * @returns {any[]}
     * @memberof SettingModel
     */
    public getAppMenuItems(): any[] {
        return this.items;
    }

	/**
	 * 根据名称获取菜单组
	 *
	 * @param {string} name
	 * @returns {*}
	 * @memberof SettingModel
	 */
	public getMenuGroup(name: string): any {
		return this.items.find((item: any) => Object.is(item.name, name));
	}

    /**
     * 获取所有应用功能集合
     *
     * @returns {any[]}
     * @memberof SettingModel
     */
    public getAppFuncs(): any[] {
        return this.funcs;
    }
}