/**
 * AbstractInfo 部件模型
 *
 * @export
 * @class AbstractInfoModel
 */
export default class AbstractInfoModel {

  /**
    * 获取数据项集合
    *
    * @returns {any[]}
    * @memberof AbstractInfoModel
    */
  public getDataItems(): any[] {
    return [
      {
        name: 'decisionmaker',
      },
      {
        name: 'totallineitemamount',
      },
      {
        name: 'processid',
      },
      {
        name: 'discountpercentage',
      },
      {
        name: 'pricingerrorcode',
      },
      {
        name: 'totalamount',
      },
      {
        name: 'totaltax_base',
      },
      {
        name: 'totaltax',
      },
      {
        name: 'updateman',
      },
      {
        name: 'estimatedvalue_base',
      },
      {
        name: 'presentfinalproposal',
      },
      {
        name: 'developproposal',
      },
      {
        name: 'opportunityratingcode',
      },
      {
        name: 'totalamount_base',
      },
      {
        name: 'totalamountlessfreight',
      },
      {
        name: 'description',
      },
      {
        name: 'identifycompetitors',
      },
      {
        name: 'updatedate',
      },
      {
        name: 'sendthankyounote',
      },
      {
        name: 'totaldiscountamount_base',
      },
      {
        name: 'totallineitemdiscountamount',
      },
      {
        name: 'purchaseprocess',
      },
      {
        name: 'traversedpath',
      },
      {
        name: 'captureproposalfeedback',
      },
      {
        name: 'finaldecisiondate',
      },
      {
        name: 'stepid',
      },
      {
        name: 'resolvefeedback',
      },
      {
        name: 'budgetamount_base',
      },
      {
        name: 'ownername',
      },
      {
        name: 'pursuitdecision',
      },
      {
        name: 'revenuesystemcalculated',
      },
      {
        name: 'scheduleproposalmeeting',
      },
      {
        name: 'closeprobability',
      },
      {
        name: 'utcconversiontimezonecode',
      },
      {
        name: 'presentproposal',
      },
      {
        name: 'schedulefollowup_prospect',
      },
      {
        name: 'statuscode',
      },
      {
        name: 'actualclosedate',
      },
      {
        name: 'confirminterest',
      },
      {
        name: 'customerid',
      },
      {
        name: 'salesstage',
      },
      {
        name: 'opportunity',
        prop: 'opportunityid',
      },
      {
        name: 'onholdtime',
      },
      {
        name: 'qualificationcomments',
      },
      {
        name: 'accountname',
      },
      {
        name: 'schedulefollowup_qualify',
      },
      {
        name: 'participatesinworkflow',
      },
      {
        name: 'exchangerate',
      },
      {
        name: 'stepname',
      },
      {
        name: 'customerneed',
      },
      {
        name: 'importsequencenumber',
      },
      {
        name: 'completeinternalreview',
      },
      {
        name: 'evaluatefit',
      },
      {
        name: 'salesstagecode',
      },
      {
        name: 'identifypursuitteam',
      },
      {
        name: 'contactname',
      },
      {
        name: 'initialcommunication',
      },
      {
        name: 'versionnumber',
      },
      {
        name: 'freightamount_base',
      },
      {
        name: 'teamsfollowed',
      },
      {
        name: 'proposedsolution',
      },
      {
        name: 'filedebrief',
      },
      {
        name: 'budgetamount',
      },
      {
        name: 'budgetstatus',
      },
      {
        name: 'discountamount_base',
      },
      {
        name: 'completefinalproposal',
      },
      {
        name: 'discountamount',
      },
      {
        name: 'customername',
      },
      {
        name: 'need',
      },
      {
        name: 'stageid',
      },
      {
        name: 'freightamount',
      },
      {
        name: 'actualvalue',
      },
      {
        name: 'ibizprivate',
      },
      {
        name: 'timezoneruleversionnumber',
      },
      {
        name: 'createdate',
      },
      {
        name: 'prioritycode',
      },
      {
        name: 'totallineitemamount_base',
      },
      {
        name: 'estimatedclosedate',
      },
      {
        name: 'currentsituation',
      },
      {
        name: 'actualvalue_base',
      },
      {
        name: 'customerpainpoints',
      },
      {
        name: 'totaldiscountamount',
      },
      {
        name: 'opportunityname',
      },
      {
        name: 'ownertype',
      },
      {
        name: 'identifycustomercontacts',
      },
      {
        name: 'timeline',
      },
      {
        name: 'lastonholdtime',
      },
      {
        name: 'totalamountlessfreight_base',
      },
      {
        name: 'estimatedvalue',
      },
      {
        name: 'emailaddress',
      },
      {
        name: 'statecode',
      },
      {
        name: 'purchasetimeframe',
      },
      {
        name: 'createman',
      },
      {
        name: 'quotecomments',
      },
      {
        name: 'customertype',
      },
      {
        name: 'overriddencreatedon',
      },
      {
        name: 'ownerid',
      },
      {
        name: 'slaname',
      },
      {
        name: 'parentcontactid',
      },
      {
        name: 'campaignid',
      },
      {
        name: 'transactioncurrencyid',
      },
      {
        name: 'parentaccountid',
      },
      {
        name: 'pricelevelid',
      },
      {
        name: 'originatingleadid',
      },
      {
        name: 'slaid',
      },
      {
        name: 'originatingleadname',
      },
      {
        name: 'parentaccountname',
      },
      {
        name: 'campaignname',
      },
      {
        name: 'parentcontactname',
      },
      {
        name: 'transactioncurrencyname',
      },
      {
        name: 'pricelevelname',
      },
    ]
  }


}